# Class webdriver.WebElement

code »

    webdriver.promise.Promise
      └ webdriver.promise.Deferred
          └ webdriver.WebElement

Represents a DOM element. WebElements can be found by searching from the document root using a `webdriver.WebDriver` instance, or by searching under another `webdriver.WebElement`:

       driver.get('http://www.google.com');
       var searchForm = driver.findElement(By.tagName('form'));
       var searchBox = searchForm.findElement(By.name('q'));
       searchBox.sendKeys('webdriver');

The WebElement is implemented as a promise for compatibility with the promise API. It will always resolve itself when its internal state has been fully resolved and commands may be issued against the element. This can be used to catch errors when an element cannot be located on the page:

       driver.findElement(By.id('not-there')).then(function(element) {
         alert('Found an element that was not expected to be there!');
       }, function(error) {
         alert('The element was not found, as expected');
       });

## Constructor

webdriver.WebElement ( driver, id )

Parameters
driver: `!webdriver.WebDriver` The parent WebDriver instance for this element. id: `!(string|webdriver.promise.Promise)` Either the opaque ID for the underlying DOM element assigned by the server, or a promise that will resolve to that ID or another WebElement.

Show:Public Protected Private

## Instance Methods

### Defined in `webdriver.WebElement`

code »clear ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to clear the `value` of this element. This command has no effect if the underlying DOM element is neither a text INPUT element nor a TEXTAREA element.

Returns
A promise that will be resolved when the element has been cleared.

code »click ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to click on this element.

Returns
A promise that will be resolved when the click command has completed.

code »findElement ( locator ) ⇒ `!webdriver.WebElement`

Schedule a command to find a descendant of this element. If the element cannot be found, a `bot.ErrorCode.NO_SUCH_ELEMENT` result will be returned by the driver. Unlike other commands, this error cannot be suppressed. In other words, scheduling a command to find an element doubles as an assert that the element is present on the page. To test whether an element is present on the page, use `#isElementPresent` instead.

The search criteria for an element may be defined using one of the factories in the `webdriver.By` namespace, or as a short-hand `webdriver.By.Hash` object. For example, the following two statements are equivalent: ``

     var e1 = element.findElement(By.id('foo'));
     var e2 = element.findElement({id:'foo'});

You may also provide a custom locator function, which takes as input this WebDriver instance and returns a `webdriver.WebElement`, or a promise that will resolve to a WebElement. For example, to find the first visible link on a page, you could write: ``

     var link = element.findElement(firstVisibleLink);

     function firstVisibleLink(element) {
       var links = element.findElements(By.tagName('a'));
       return webdriver.promise.filter(links, function(link) {
         return links.isDisplayed();
       }).then(function(visibleLinks) {
         return visibleLinks[0];
       });
     }

Parameters
locator: `!(webdriver.Locator|webdriver.By.Hash|Function)` The locator strategy to use when searching for the element.
Returns
A WebElement that can be used to issue commands against the located element. If the element is not found, the element will be invalidated and all scheduled commands aborted.

code »findElements ( locator ) ⇒ `!webdriver.promise.Promise`

Schedules a command to find all of the descendants of this element that match the given search criteria.

Parameters
locator: `!(webdriver.Locator|webdriver.By.Hash|Function)` The locator strategy to use when searching for the elements.
Returns
A promise that will resolve to an array of WebElements.

code »getAttribute ( attributeName ) ⇒ `!webdriver.promise.Promise`

Schedules a command to query for the value of the given attribute of the element. Will return the current value, even if it has been modified after the page has been loaded. More exactly, this method will return the value of the given attribute, unless that attribute is not present, in which case the value of the property with the same name is returned. If neither value is set, null is returned (for example, the "value" property of a textarea element). The "style" attribute is converted as best can be to a text representation with a trailing semi-colon. The following are deemed to be "boolean" attributes and will return either "true" or null:

async, autofocus, autoplay, checked, compact, complete, controls, declare, defaultchecked, defaultselected, defer, disabled, draggable, ended, formnovalidate, hidden, indeterminate, iscontenteditable, ismap, itemscope, loop, multiple, muted, nohref, noresize, noshade, novalidate, nowrap, open, paused, pubdate, readonly, required, reversed, scoped, seamless, seeking, selected, spellcheck, truespeed, willvalidate

Finally, the following commonly mis-capitalized attribute/property names are evaluated as expected:

- "class"
- "readonly"

Parameters
attributeName: `string` The name of the attribute to query.
Returns
A promise that will be resolved with the attribute's value. The returned value will always be either a string or null.

code »getCssValue ( cssStyleProperty ) ⇒ `!webdriver.promise.Promise`

Schedules a command to query for the computed style of the element represented by this instance. If the element inherits the named style from its parent, the parent will be queried for its value. Where possible, color values will be converted to their hex representation (e.g. #00ff00 instead of rgb(0, 255, 0)).

Warning: the value returned will be as the browser interprets it, so it may be tricky to form a proper assertion.

Parameters
cssStyleProperty: `string` The name of the CSS style property to look up.
Returns
A promise that will be resolved with the requested CSS value.

code »getDriver ( ) ⇒ `!webdriver.WebDriver`

Returns
The parent driver for this instance.

code »getInnerHtml ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to retrieve the inner HTML of this element.

Returns
A promise that will be resolved with the element's inner HTML.

code »getLocation ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to compute the location of this element in page space.

Returns
A promise that will be resolved to the element's location as a `{x:number, y:number}` object.

code »getOuterHtml ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to retrieve the outer HTML of this element.

Returns
A promise that will be resolved with the element's outer HTML.

code »getSize ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to compute the size of this element's bounding box, in pixels.

Returns
A promise that will be resolved with the element's size as a `{width:number, height:number}` object.

code »getTagName ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to query for the tag/node name of this element.

Returns
A promise that will be resolved with the element's tag name.

code »getText ( ) ⇒ `!webdriver.promise.Promise`

Get the visible (i.e. not hidden by CSS) innerText of this element, including sub-elements, without any leading or trailing whitespace.

Returns
A promise that will be resolved with the element's visible text.

code »isDisplayed ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to test whether this element is currently displayed.

Returns
A promise that will be resolved with whether this element is currently visible on the page.

code »isElementPresent ( locator ) ⇒ `!webdriver.promise.Promise.<boolean>`

Schedules a command to test if there is at least one descendant of this element that matches the given search criteria.

Parameters
locator: `!(webdriver.Locator|webdriver.By.Hash|Function)` The locator strategy to use when searching for the element.
Returns
A promise that will be resolved with whether an element could be located on the page.

code »isEnabled ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to query whether the DOM element represented by this instance is enabled, as dicted by the `disabled` attribute.

Returns
A promise that will be resolved with whether this element is currently enabled.

code »isSelected ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to query whether this element is selected.

Returns
A promise that will be resolved with whether this element is currently selected.

code »schedule_ ( command, description ) ⇒ `!webdriver.promise.Promise`

Schedules a command that targets this element with the parent WebDriver instance. Will ensure this element's ID is included in the command parameters under the "id" key.

Parameters
command: `!webdriver.Command` The command to schedule. description: `string` A description of the command for debugging.
Returns
A promise that will be resolved with the command result.

code »sendKeys ( var_args ) ⇒ `!webdriver.promise.Promise`

Schedules a command to type a sequence on the DOM element represented by this instance.

Modifier keys (SHIFT, CONTROL, ALT, META) are stateful; once a modifier is processed in the keysequence, that key state is toggled until one of the following occurs:

- The modifier key is encountered again in the sequence. At this point the state of the key is toggled (along with the appropriate keyup/down events).
- The `webdriver.Key.NULL` key is encountered in the sequence. When this key is encountered, all modifier keys current in the down state are released (with accompanying keyup events). The NULL key can be used to simulate common keyboard shortcuts: `

           element.sendKeys("text was",
                            webdriver.Key.CONTROL, "a", webdriver.Key.NULL,
                            "now text is");
           // Alternatively:
           element.sendKeys("text was",
                            webdriver.Key.chord(webdriver.Key.CONTROL, "a"),
                            "now text is");

  `
- The end of the keysequence is encountered. When there are no more keys to type, all depressed modifier keys are released (with accompanying keyup events).

Note: On browsers where native keyboard events are not yet supported (e.g. Firefox on OS X), key events will be synthesized. Special punctionation keys will be synthesized according to a standard QWERTY en-us keyboard layout.

Parameters
var_args: `...string` The sequence of keys to type. All arguments will be joined into a single sequence (var_args is permitted for convenience).
Returns
A promise that will be resolved when all keys have been typed.

code »submit ( ) ⇒ `!webdriver.promise.Promise`

Schedules a command to submit the form containing this element (or this element if it is a FORM element). This command is a no-op if the element is not contained in a form.

Returns
A promise that will be resolved when the form has been submitted.

code »toWireValue ( ) ⇒ `!webdriver.promise.Promise`

Returns
A promise that resolves to this element's JSON representation as defined by the WebDriver wire protocol.

### Defined in `webdriver.promise.Deferred`

code »errback ( opt_error )

Rejects this promise. If the error is itself a promise, this instance will be chained to it and be rejected with the error's resolved value.

Parameters
opt_error: `*=` The rejection reason, typically either a `Error` or a `string`.

code »fulfill ( opt_value )

Resolves this promise with the given value. If the value is itself a promise and not a reference to this deferred, this instance will wait for it before resolving.

Parameters
opt_value: `*=` The resolved value.

code »reject ( opt_error )

Rejects this promise. If the error is itself a promise, this instance will be chained to it and be rejected with the error's resolved value.

Parameters
opt_error: `*=` The rejection reason, typically either a `Error` or a `string`.

code »removeAll ( )

Removes all of the listeners previously registered on this deferred.

Throws
`Error` If this deferred has already been resolved.

### Defined in `webdriver.promise.Promise`

code »addBoth ( callback, opt_self ) ⇒ `!webdriver.promise.Promise`
Deprecated: Use `#thenFinally()` instead.

Registers a function to be invoked when this promise is either rejected or resolved. This function is provided for backwards compatibility with the Dojo Deferred API.

Parameters
callback: `Function` The function to call when this promise is either resolved or rejected. The function should expect a single argument: the resolved value or rejection error. opt_self: `!Object=` The object which |this| should refer to when the function is invoked.
Returns
A new promise which will be resolved with the result of the invoked callback.

code »addCallback ( callback, opt_self ) ⇒ `!webdriver.promise.Promise`
Deprecated: Use `#then()` instead.

Registers a function to be invoked when this promise is successfully resolved. This function is provided for backwards compatibility with the Dojo Deferred API.

Parameters
callback: `Function` The function to call if this promise is successfully resolved. The function should expect a single argument: the promise's resolved value. opt_self: `!Object=` The object which |this| should refer to when the function is invoked.
Returns
A new promise which will be resolved with the result of the invoked callback.

code »addCallbacks ( callback, errback, opt_self ) ⇒ `!webdriver.promise.Promise`
Deprecated: Use `#then()` instead.

An alias for `webdriver.promise.Promise.prototype.then` that permits the scope of the invoked function to be specified. This function is provided for backwards compatibility with the Dojo Deferred API.

Parameters
callback: `Function` The function to call if this promise is successfully resolved. The function should expect a single argument: the promise's resolved value. errback: `Function` The function to call if this promise is rejected. The function should expect a single argument: the rejection reason. opt_self: `!Object=` The object which |this| should refer to when the function is invoked.
Returns
A new promise which will be resolved with the result of the invoked callback.

code »addErrback ( errback, opt_self ) ⇒ `!webdriver.promise.Promise`
Deprecated: Use `#thenCatch()` instead.

Registers a function to be invoked when this promise is rejected. This function is provided for backwards compatibility with the Dojo Deferred API.

Parameters
errback: `Function` The function to call if this promise is rejected. The function should expect a single argument: the rejection reason. opt_self: `!Object=` The object which |this| should refer to when the function is invoked.
Returns
A new promise which will be resolved with the result of the invoked callback.

code »cancel ( reason )

Cancels the computation of this promise's value, rejecting the promise in the process.

Parameters
reason: `*` The reason this promise is being cancelled. If not an `Error`, one will be created using the value's string representation.

code »isPending ( ) ⇒ `boolean`

Returns
Whether this promise's value is still being computed.

code »then ( opt_callback, opt_errback ) ⇒ `!webdriver.promise.Promise`

Registers listeners for when this instance is resolved. This function most overridden by subtypes.

Parameters
opt_callback: `Function=` The function to call if this promise is successfully resolved. The function should expect a single argument: the promise's resolved value. opt_errback: `Function=` The function to call if this promise is rejected. The function should expect a single argument: the rejection reason.
Returns
A new promise which will be resolved with the result of the invoked callback.

code »thenCatch ( errback ) ⇒ `!webdriver.promise.Promise`

Registers a listener for when this promise is rejected. This is synonymous with the `catch` clause in a synchronous API:

       // Synchronous API:
       try {
         doSynchronousWork();
       } catch (ex) {
         console.error(ex);
       }

       // Asynchronous promise API:
       doAsynchronousWork().thenCatch(function(ex) {
         console.error(ex);
       });

Parameters
errback: `!Function` The function to call if this promise is rejected. The function should expect a single argument: the rejection reason.
Returns
A new promise which will be resolved with the result of the invoked callback.

code »thenFinally ( callback ) ⇒ `!webdriver.promise.Promise`

Registers a listener to invoke when this promise is resolved, regardless of whether the promise's value was successfully computed. This function is synonymous with the `finally` clause in a synchronous API:

       // Synchronous API:
       try {
         doSynchronousWork();
       } finally {
         cleanUp();
       }

       // Asynchronous promise API:
       doAsynchronousWork().thenFinally(cleanUp);

Note: similar to the `finally` clause, if the registered callback returns a rejected promise or throws an error, it will silently replace the rejection error (if any) from this promise:

       try {
         throw Error('one');
       } finally {
         throw Error('two');  // Hides Error: one
       }

       webdriver.promise.rejected(Error('one'))
           .thenFinally(function() {
             throw Error('two');  // Hides Error: one
           });

Parameters
callback

## Instance Properties

### Defined in `webdriver.WebElement`

code »driver_ : `!webdriver.WebDriver`

The parent WebDriver instance for this element.

code »id_ : `!webdriver.promise.Promise`

A promise that resolves to the JSON representation of this WebElement's ID, as defined by the WebDriver wire protocol.

### Defined in `webdriver.promise.Deferred`

code »webdriver.promise.Deferred.prototype.promise : `webdriver.promise.Promise`

Represents the eventual value of a completed operation. Each promise may be in one of three states: pending, resolved, or rejected. Each promise starts in the pending state and may make a single transition to either a fulfilled or failed state.

This class is based on the Promise/A proposal from CommonJS. Additional functions are provided for API compatibility with Dojo Deferred objects.

## Static Functions

code »webdriver.WebElement.equals ( a, b ) ⇒ `!webdriver.promise.Promise`

Compares to WebElements for equality.

Parameters
a: `!webdriver.WebElement` A WebElement. b: `!webdriver.WebElement` A WebElement.
Returns
A promise that will be resolved to whether the two WebElements are equal.

## Static Properties

code »webdriver.WebElement.ELEMENT_KEY : `string`

The property key used in the wire protocol to indicate that a JSON object contains the ID of a WebElement.

code »webdriver.WebElement.superClass_ : `webdriver.promise.Deferred.prototype`